MODULE Font;
(* =========================================================================
   RISC5 Oberon LCD Font File Handling   

   Description:
     Read bitmap fonts from a file

   (c) 2019 CFB Software   
   http://www.astrobe.com  

  Permission to use, copy, modify, and/or distribute this software and its
  accompanying documentation (the "Software") for any purpose with or
  without fee is hereby granted, provided that the above copyright notice
  and this permission notice appear in all copies.
  
  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHORS DISCLAIM ALL WARRANTIES
  WITH REGARD TO THE SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
  MERCHANTABILITY, FITNESS AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
  AUTHORS BE LIABLE FOR ANY CLAIM, SPECIAL, DIRECT, INDIRECT, OR
  CONSEQUENTIAL DAMAGES OR ANY DAMAGES OR LIABILITY WHATSOEVER, WHETHER IN
  AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  CONNECTION WITH THE DEALINGS IN OR USE OR PERFORMANCE OF THE SOFTWARE.
  ========================================================================= *)

IMPORT Files;

CONST
  Width* = 6;
  Height* = 8;
  CharCount = 95 * 2;
  
VAR
  bitmap: ARRAY CharCount OF INTEGER;

PROCEDURE Load*(name: ARRAY OF CHAR): BOOLEAN;
VAR 
  i: INTEGER;
  ok: BOOLEAN;
  F: Files.File;
  R: Files.Rider;
BEGIN
  ok := FALSE;
  F := Files.Old(name);
  IF F # NIL THEN
    ok := TRUE;
    Files.Set(R, F, 0);
    FOR i := 0 TO CharCount - 1 DO
      Files.ReadInt(R, bitmap[i]) 
    END
  END;
  Files.Close(F)
  RETURN ok
END Load;


PROCEDURE CharToBitmap*(ch: CHAR; VAR bmp1, bmp2: INTEGER);
VAR
  index: INTEGER;
BEGIN
  IF ORD(ch) < ORD(" ") THEN ch := "." END;
  index := (ORD(ch) - ORD(" ")) * 2;
  bmp1 := bitmap[index];
  bmp2 := bitmap[index + 1]
END CharToBitmap;
  
END Font.
