MODULE TextDisplay;
(* =========================================================================
   RISC5 Oberon LCD Text Display Demo  

   Description:
     Write line-oriented output to an LCD display

   (c) 2019 CFB Software   
   http://www.astrobe.com  

  Permission to use, copy, modify, and/or distribute this software and its
  accompanying documentation (the "Software") for any purpose with or
  without fee is hereby granted, provided that the above copyright notice
  and this permission notice appear in all copies.
  
  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHORS DISCLAIM ALL WARRANTIES
  WITH REGARD TO THE SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
  MERCHANTABILITY, FITNESS AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
  AUTHORS BE LIABLE FOR ANY CLAIM, SPECIAL, DIRECT, INDIRECT, OR
  CONSEQUENTIAL DAMAGES OR ANY DAMAGES OR LIABILITY WHATSOEVER, WHETHER IN
  AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  CONNECTION WITH THE DEALINGS IN OR USE OR PERFORMANCE OF THE SOFTWARE.
  ========================================================================= *)

IMPORT Display, Timer;

CONST
  Black   = Display.Black;
  Red     = Display.Red;
  Green   = Display.Green;
  Blue    = Display.Blue;
  White   = Display.White;
  Cyan    = Display.Cyan;
  Magenta = Display.Magenta;
  Yellow  = Display.Yellow;

PROCEDURE OutLine(colour: INTEGER; s: ARRAY OF CHAR);
BEGIN
  Display.SetColour(colour);
  Display.String(s);
  Display.Ln()
END OutLine;
  
PROCEDURE Run*;
BEGIN
  Display.Init();
  Display.String("Top Line"); Display.Ln();
  Display.String("Test of sending"); Display.Ln();
  Display.String("characters to"); Display.Ln();
  Display.String("the display."); Display.Ln();
  Display.Ln();
  Display.String("Display.Int: "); Display.Int(-1); Display.Ln();
  Display.String("Long lines automatically wrap over to the next lines"); Display.Ln();
  Timer.MSecDelay(2000);
  Display.Ln();
  Display.String("The display scrolls up when full"); Display.Ln();
  Timer.MSecDelay(1000);
  Display.Clear(); 
  Display.String("Colours are:"); Display.Ln();
  OutLine(Red, "Red"); 
  OutLine(Green, "Green"); 
  OutLine(Blue, "Blue"); 
  OutLine(White, "White"); 
  OutLine(Cyan, "Cyan"); 
  OutLine(Magenta, "Magenta"); 
  OutLine(Yellow, "Yellow") 
END Run;

END TextDisplay.
    
